"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const leveldb_adapter_test_1 = require("./lapisdb/tests/leveldb.adapter.test");
const _1 = require(".");
const datastore_manager_1 = require("./lapisdb/datastore/datastore.manager");
class Human {
    constructor(name, age) {
        this.name = name;
        this.age = age;
    }
}
exports.Human = Human;
class Planet extends _1.Model {
    constructor(name, index) {
        super(Planet);
        this.name = name;
        this.index = index;
        this.people = [];
    }
    addHuman() {
        this.people.push(new Human(`Citizen of planet ${this.name} number ${this.people.length + 1}`, 0));
    }
    age() {
        this.people.forEach(human => human.age += 1);
    }
}
exports.Planet = Planet;
beforeEach(() => __awaiter(this, void 0, void 0, function* () {
    exports.testStore = new _1.Datastore('test', Planet, new leveldb_adapter_test_1.LevelDbAdapter(Planet, { name: 'test', directory: './database' }));
    datastore_manager_1.DatastoreManager.register(exports.testStore);
    exports.testStore.getItems({ pagination: {} });
    const items = yield exports.testStore.getItems();
    for (const item of items) {
        yield item.delete();
    }
}));
afterEach(() => __awaiter(this, void 0, void 0, function* () {
    yield exports.testStore.adapter.close();
}));
exports.testCreateRandomPlanets = (push = false) => __awaiter(this, void 0, void 0, function* () {
    const data = [];
    for (let i = 0; i < 100; i++) {
        data.push(new Planet(`Planet ${i}`, i));
    }
    if (push) {
        for (const item of data) {
            yield item.save();
        }
    }
    return data;
});
//# sourceMappingURL=index.test.config.js.map