import { Model } from '../../model/model';
export declare abstract class DatastoreAdapter<T extends Model<T>> {
    abstract open(): Promise<void>;
    abstract close(): Promise<void>;
    abstract get(id: string): Promise<T | null>;
    abstract put(item: T): Promise<T>;
    abstract remove(id: string): Promise<T | null>;
    abstract stream(callback: (item: T) => void): Promise<void>;
}
