"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class DatastoreManager {
    static register(datastore) {
        if (DatastoreManager.datastores == null) {
            DatastoreManager.datastores = new Map();
        }
        DatastoreManager.datastores.set(datastore.type, datastore);
    }
    static get(type) {
        const store = DatastoreManager.datastores.get(type);
        if (!store) {
            throw new Error(`Datastore with type ${type} was not found. Perhaps you forgot to call DatastoreManager.register()?`);
        }
        return store;
    }
    static initialize(...datastores) {
        DatastoreManager.datastores = new Map();
        datastores.forEach(DatastoreManager.register);
    }
}
DatastoreManager.datastores = new Map();
exports.DatastoreManager = DatastoreManager;
//# sourceMappingURL=datastore.manager.js.map