import { IModelMetadata, IFilledModelMetadata } from './model.metadata';
import { ClassType } from 'lapisdb';
import { Reference } from './reference';
export declare abstract class Model<T extends Model<T>> {
    meta: IModelMetadata;
    private store;
    constructor(type: ClassType<T>);
    hasMetadata(): this is {
        meta: IFilledModelMetadata;
    };
    getReference(): Reference<T>;
    save(): Promise<this>;
    delete(): Promise<void>;
}
