"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const class_transformer_1 = require("class-transformer");
const metadata_utils_1 = require("../datastore/metadata.utils");
const datastore_manager_1 = require("../datastore/datastore.manager");
const reference_1 = require("./reference");
class Model {
    constructor(type) {
        const datastore = datastore_manager_1.DatastoreManager.get(type);
        this.store = () => datastore;
        this.meta = {};
    }
    hasMetadata() {
        return this.meta.id != null && this.meta.created != null && this.meta.updated != null;
    }
    getReference() {
        if (!this.hasMetadata()) {
            throw new Error('Item has no metadata.');
        }
        return new reference_1.Reference(this.meta.id);
    }
    save() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.hasMetadata()) {
                this.meta = metadata_utils_1.MetadataUtils.getNewMetadata();
            }
            yield this.store().adapter.put(this);
            return this;
        });
    }
    delete() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.hasMetadata()) {
                throw Error('Item has no metadata.');
            }
            yield this.store().adapter.remove(this.meta.id);
        });
    }
}
__decorate([
    class_transformer_1.Exclude({ toPlainOnly: true }),
    __metadata("design:type", Function)
], Model.prototype, "store", void 0);
exports.Model = Model;
//# sourceMappingURL=model.js.map