import { Model } from '../model/model';
import { BaseOperation } from './database.operations';
import { Datastore } from '../datastore/datastore';
export declare class DeleteOperation<T extends Model<T>> implements BaseOperation<T> {
    private store;
    private identifier?;
    constructor(store: Datastore<T>, id?: string);
    value(item: T | string): this;
    run(): Promise<T | null>;
}
export declare class BatchedDeleteOperation<T extends Model<T>> implements BaseOperation<T> {
    private store;
    private identifiers;
    constructor(store: Datastore<T>);
    value(item: T | string): this;
    values(item: T[] | string[]): this;
    run(): Promise<T[]>;
}
