import { BaseOperation } from './database.operations';
import { Datastore } from '../datastore/datastore';
import { Model } from '../model/model';
import { FilterMethod } from '../datastore/interfaces/filter.type';
import { IPaginationData } from '../datastore/interfaces/pagination.type';
export declare class GetOperation<T extends Model<T>> implements BaseOperation<T> {
    private filterMethod;
    private paginationData;
    private store;
    constructor(store: Datastore<T>);
    filter(method: FilterMethod<T>): this;
    id(id: string): this;
    paginate(data: IPaginationData): this;
    run(): Promise<T[]>;
    one(): Promise<T | null>;
    first(): Promise<T | null>;
    last(): Promise<T | null>;
}
