import { DatastoreAdapter, Model, ClassType } from '../../.';
export declare class LevelDbAdapter<T extends Model<T>> implements DatastoreAdapter<T> {
    private name;
    private type;
    private level;
    private convertToClass;
    open(): Promise<void>;
    close(): Promise<void>;
    get(id: string): Promise<T | null>;
    put(item: T): Promise<T>;
    remove(id: string): Promise<T | null>;
    stream(callback: (item: T) => void): Promise<void>;
    constructor(type: ClassType<T>, options: {
        name: string;
        directory: string;
    });
}
